package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.annotation.SysLogger;
import com.mh.user.entity.EnergyEntity;
import com.mh.user.entity.MaintainInfoEntity;
import com.mh.user.service.BuildingService;
import com.mh.user.service.MaintainInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("maintain")
public class MaintainInfoController {

  @Autowired
    MaintainInfoService maintainInfoService;

  @Autowired
    BuildingService buildingService;

  @SysLogger(title="维修保养",optDesc = "保存维修保养记录")
  @PostMapping("/save")
  public HttpResult saveMaintainInfo(@RequestBody MaintainInfoEntity maintainInfoEntity){
    try{
        maintainInfoService.saveMaintainInfo(maintainInfoEntity);
        return  HttpResult.ok();
    }catch (Exception e){
        return  HttpResult.error();
    }
  }

  @SysLogger(title="维修保养",optDesc = "修改维修保养记录")
  @PostMapping("/update")
  public HttpResult updateMaintainInfo(@RequestBody MaintainInfoEntity maintainInfoEntity){
        try{
            maintainInfoService.updateMaintainInfo(maintainInfoEntity);
            return  HttpResult.ok();
        }catch (Exception e){
            return  HttpResult.error();
        }
  }

  @SysLogger(title="维修保养",optDesc = "查询维修保养记录")
  @PostMapping("/query")
  public HttpResult queryMaintainInfo(@RequestParam(value = "curDate",required = false) String curDate,
                                      @RequestParam(value = "buildingId",required = false) String buildingId,
                                      @RequestParam(value = "deviceType",required = false) String deviceType,
                                      @RequestParam(value = "page") int page,
                                      @RequestParam(value = "limit") int limit){
        try{
            List<MaintainInfoEntity> list=maintainInfoService.queryMaintainInfo(curDate,buildingId,deviceType,page,limit);
            int count=maintainInfoService.getMaintainInfoCount(curDate,buildingId,deviceType,page,limit);
            return  HttpResult.ok(count,list);
        }catch (Exception e){
            e.printStackTrace();
            return  HttpResult.error();
        }
  }

  @SysLogger(title="维修保养",optDesc = "删除维修保养记录")
  @PostMapping("/delete")
  public HttpResult deleteMaintainInfo(@RequestParam(value = "id") String id){
        try{
            maintainInfoService.deleteMaintainInfo(id);
            return  HttpResult.ok();
        }catch (Exception e){
            return  HttpResult.error();
        }
  }

}
