package com.mh.user.controller;

import com.alibaba.fastjson2.JSONObject;
import com.mh.common.http.HttpResult;
import com.mh.user.entity.ReportParamEntity;
import com.mh.user.service.ReportService;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @author ljf
 * @title ：报表查询接口
 * @description ：
 * @updateTime 2020-07-03
 * @throws ：
 */
@RestController
@RequestMapping("/report")
public class ReportController {

    private final ReportService reportService;

    public ReportController(ReportService reportService) {
        this.reportService = reportService;
    }

    @GetMapping("/indexInfo")
    public HttpResult queryAllTarget(@RequestParam(value = "type",required = false) String type) {
        List<ReportParamEntity> reportParamEntities = reportService.queryAllTarget(type);
        List<ReportParamEntity> firstLevel = reportParamEntities.stream().filter(p -> String.valueOf(p.getParentId()).equals("0")).collect(Collectors.toList());
        System.out.println(firstLevel.toString());
        firstLevel.parallelStream().forEach(p -> {
            setChild(p, reportParamEntities);
        });
        JSONObject menuListJson = new JSONObject();
        menuListJson.put("indexInfo",firstLevel);
        System.out.println(menuListJson.toJSONString());
        return HttpResult.ok("success", menuListJson);

    }

    /**
     * 设置子元素
     * 2018.06.09
     *
     * @param p
     * @param reportParamEntities
     */
    private void setChild(ReportParamEntity p, List<ReportParamEntity> reportParamEntities) {
//        System.out.println(p.getId());
        List<ReportParamEntity> child = reportParamEntities.parallelStream().filter(a -> String.valueOf(a.getParentId()).equals(String.valueOf(p.getId()))).collect(Collectors.toList());
        p.setChildren(child);
        if (!CollectionUtils.isEmpty(child)) {
            child.parallelStream().forEach(c -> {
                //递归设置子元素，多级菜单支持
                setChild(c, reportParamEntities);
            });
        }
    }

}
