package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.entity.UseForecastEntity;
import com.mh.user.service.BuildingService;
import com.mh.user.service.DeviceFloorService;
import com.mh.user.service.UseForecastService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("forecast")
public class UseForecastController {

    @Autowired
    UseForecastService useForecastService;

    @Autowired
    BuildingService buildingService;

    @Autowired
    DeviceFloorService deviceFloorService;

    @PostMapping("/save")
    public HttpResult saveUseForecast(@RequestBody UseForecastEntity useForecastEntity){
        try{
            useForecastService.saveUseForecast(useForecastEntity);
            return  HttpResult.ok();
        }catch (Exception e){
            return  HttpResult.error("保存出错!");
        }
    }

    @PostMapping("/update")
    public HttpResult updateUseForecast(@RequestBody UseForecastEntity useForecastEntity){
        try{
            useForecastService.updateUseForecast(useForecastEntity);
            return  HttpResult.ok();
        }catch (Exception e){
            e.printStackTrace();
            return  HttpResult.error("修改出错!");
        }

    }

    @PostMapping("/query")
    public HttpResult queryUseForecast(@RequestParam(value = "buildingId",required = true) String buildingId,
                                     @RequestParam(value = "deviceName",required = true) String deviceName,
                                     @RequestParam(value = "curDate",required =true) String curDate,
                                     @RequestParam(value = "page",required = true) int page,
                                     @RequestParam(value = "limit",required = true) int limit){
        try{
            List<UseForecastEntity> list=new ArrayList<UseForecastEntity>();
//            String buildingId=buildingService.selectBuildingId(buildingName);
            String deviceId=deviceFloorService.selectDeviceId(deviceName,"水箱",buildingId);
            list=useForecastService.queryUseForecast(buildingId,deviceId,curDate,page,limit);
            int count=useForecastService.getCount(buildingId,deviceId,curDate,page,limit);
            return  HttpResult.ok(count,list);
        }catch (Exception e){
            e.printStackTrace();
            return  HttpResult.error("查询出错!");
        }

    }
}
