package com.mh.user.dynamic.datasource;

/**
 * @author chison
 * @date 2020-04-02 09:40
 * @Description 通过ThreadLocal维护一个全局唯一的map来实现数据源的动态切换
 */
public class DataSourceContextHolder {

    private static final ThreadLocal<String> contextHolder = new ThreadLocal<String>();

    public static synchronized void setDBType(String dbType){
        contextHolder.set(dbType);
    }

    public static String getDBType(){
        return contextHolder.get();
    }

    public static void clearDBType(){
        contextHolder.remove();
    }
}
