package com.mh.user.entity.chart;

import com.alibaba.fastjson2.annotation.JSONType;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

/**
 * @author ljf
 * @title ：图表实体类
 * @description ：
 * @updateTime 2020-07-10
 * @throws ：
 */
@Setter
@Getter
@JSONType(orders = {"title","feature","legend","xAxis","yAxis","series","timeName"})
public class ChartEntity {

    private Title title;
    private Feature feature;
    private Legend legend;
    private XAxis xAxis;
    private List<YAxis> yAxis;
    private List<Series> series;

    public ChartEntity(Title title, Feature feature, Legend legend, XAxis xAxis, List<YAxis> yAxis, List<Series> series) {
        this.title = title;
        this.feature = feature;
        this.legend = legend;
        this.xAxis = xAxis;
        this.yAxis = yAxis;
        this.series = series;
    }

    @Override
    public String toString() {
        return "ChartEntity{" +
                "title=" + title +
                ", feature=" + feature +
                ", legend=" + legend +
                ", xAxis=" + xAxis +
                ", yAxis=" + yAxis +
                ", series=" + series +
                '}';
    }
}


