package com.mh.user.mapper;

import com.mh.user.entity.AnalysisMonthEntity;
import com.mh.user.entity.AnalysisYearEntity;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface AnalysisMapper {

    /**
     * 分析查询
     * 根据日期、楼栋查询
     * @param curDate
     * @param buildingId
     * @return
     */
    @Results(id ="rs_month",value ={
            @Result(column = "building_id",property = "buildingId" ),
            @Result(column = "building_name", property = "buildingName"),
            @Result(column = "cur_date", property = "curDate"),
            @Result(column = "item_type", property = "itemType"),
            @Result(column = "total_value", property = "totalValue")
    })

    @Select("select * from  analysis_elect_year  where cur_date=#{curDate} and  building_id=#{buildingId}")
    List<AnalysisYearEntity> queryAnalysisElectYear(@Param("curDate") String curDate, @Param("buildingId") String buildingId);

    @ResultMap("rs_month")
    @Select("select * from  analysis_Water_year  where cur_date=#{curDate} and  building_id=#{buildingId}")
    List<AnalysisYearEntity> queryAnalysisWaterYear(@Param("curDate") String curDate, @Param("buildingId") String buildingId);

    @ResultMap("rs_month")
    @Select("select * from  analysis_Energy_year where cur_date=#{curDate} and  building_id=#{buildingId}")
    List<AnalysisYearEntity> queryAnalysisEnergyYear(@Param("curDate") String curDate, @Param("buildingId") String buildingId);

    @ResultMap("rs_month")
    @Select("select * from  analysis_Maintain_year where cur_date=#{curDate} and  building_id=#{buildingId}")
    List<AnalysisYearEntity> queryAnalysisMaintainYear(@Param("curDate") String curDate, @Param("buildingId") String buildingId);

    @Results(id ="rs_day",value ={
            @Result(column = "building_id",property = "buildingId" ),
            @Result(column = "building_name", property = "buildingName"),
            @Result(column = "cur_date", property = "curDate"),
            @Result(column = "item_type", property = "itemType"),
            @Result(column = "total_value", property = "totalValue")
    })

    @Select("select * from  analysis_elect_month  where cur_date=#{curDate} and  building_id=#{buildingId}")
    List<AnalysisMonthEntity> queryAnalysisElectMonth(@Param("curDate") String curDate, @Param("buildingId") String buildingId);

    @ResultMap("rs_day")
    @Select("select * from  analysis_Water_month  where cur_date=#{curDate} and  building_id=#{buildingId}")
    List<AnalysisMonthEntity> queryAnalysisWaterMonth(@Param("curDate") String curDate, @Param("buildingId") String buildingId);

    @ResultMap("rs_day")
    @Select("select * from  analysis_Energy_month where cur_date=#{curDate} and  building_id=#{buildingId}")
    List<AnalysisMonthEntity> queryAnalysisEnergyMonth(@Param("curDate") String curDate, @Param("buildingId") String buildingId);

    @ResultMap("rs_day")
    @Select("select * from  analysis_maintain_month where cur_date=#{curDate} and  building_id=#{buildingId}")
    List<AnalysisMonthEntity> queryAnalysisMaintainMonth(@Param("curDate") String curDate, @Param("buildingId") String buildingId);

}
