package com.mh.user.mapper;

import com.mh.user.entity.DataResultEntity;
import com.mh.user.mapper.provider.DataResultProvider;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.mapping.StatementType;

import java.util.List;

@Mapper
public interface DataResultMapper {

    @Insert("insert into data_result(device_addr,device_type,building_id,last_value,last_date,cur_value,cur_date,ratio,calc_value) values (" +
            " #{deviceAddr},#{deviceType},#{buildingId},#{lastValue},#{lastDate},#{curValue},#{curDate},#{ratio},#{calcValue})")
    void saveDataResult(DataResultEntity dataResultEntity);

    @Update("<script>" +
            "  update data_result set  " +
            "  <if test='deviceAddr!=null'>  device_addr = #{deviceAddr} </if>" +
            "  <if test='deviceType!=null'> , device_type = #{deviceType} </if>" +
            "  <if test='buildingId!=null'> , building_id = #{buildingId} </if>" +
            "  <if test='lastValue!=null'> , last_value = #{lastValue} </if>" +
            "  <if test='lastDate!=null'> , last_date = #{lastDate} </if>" +
            "  <if test='curValue!=null'> , cur_value = #{curValue} </if>" +
            "  <if test='ratio!=null'> , ratio = #{ratio} </if>" +
            "  <if test='calcValue!=null'> , calc_value = #{calcValue} </if>" +
            "   where cur_date=#{curDate} and  device_addr=#{deviceAddr}  and  device_type=#{deviceType}" +
            "</script>")
    void updateDataResult(DataResultEntity dataResultEntity);

    @Results(id="rs", value = {
            @Result(property="deviceAddr",column="device_addr"),
            @Result(property="deviceType",column="device_type"),
            @Result(property="buildingId",column="building_id"),
            @Result(property="buildingName",column="building_Name"),
            @Result(property="lastValue",column="last_value"),
            @Result(property ="lastDate",column ="last_date"),
            @Result(property ="curValue",column ="cur_value"),
            @Result(property="curDate",column="cur_date"),
            @Result(property="ratio",column="ratio"),
            @Result(property="calcValue",column="calc_Value")
    })
    @SelectProvider(type = DataResultProvider.class,method = "queryDataResult")
    List<DataResultEntity> queryDataResult(@Param("buildingId") String buildingId,
                                           @Param("startDate") String startDate,
                                           @Param("endDate") String endDate,
                                           @Param("deviceType") String deviceType,
                                           @Param("page") int page,
                                           @Param("limit") int limit);


    @SelectProvider(type = DataResultProvider.class,method = "getDataResultCount")
    int getDataResultCount(@Param("buildingId") String buildingId,
                             @Param("startDate") String startDate,
                             @Param("endDate") String endDate,
                             @Param("deviceType") String deviceType,
                             @Param("page") int page,
                             @Param("limit") int limit);


    //查询单条记录
    @ResultMap("rs")
    @Select("select * from  data_result where cur_date=#{curDate} and  device_addr=#{deviceAddr}  and  device_type=#{deviceType} ")
    DataResultEntity selectDataResult(@Param("curDate") String curDate,
                         @Param("deviceAddr") String deviceAddr,
                         @Param("deviceType") String deviceType);

    //查询是否存在记录
    @Select("select count(*) from  data_result  where cur_date=#{curDate} and  device_addr=#{deviceAddr}  and  device_type=#{deviceType} ")
//    @Select("select count(*) from  data_result")
    int selectDataResultCount(@Param("curDate") String curDate,
                         @Param("deviceAddr") String deviceAddr,
                         @Param("deviceType") String deviceType);

}
