package com.mh.user.mapper;

import org.apache.ibatis.annotations.*;
import org.apache.ibatis.mapping.StatementType;

/**
 * @author nxr
 * @title ：处理数据mapper层
 * @description ：
 * @updateTime 2020-07-28
 * @throws ：
 */
@Mapper
public interface DealDataMapper {

    //按日、月和年汇总水、电用量，计算单耗、平均用量
    @Select("exec pro_energy #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proEnergy(@Param("curDate") String curDate);

    //按日、月和年汇总水、电用量，计算单耗、平均用量
    @Select("exec pro_energy2 #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proEnergy2(@Param("curDate") String curDate);

    @Select("exec pro_energy_sum #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proEnergySum(@Param("curDate") String curDate);

    @Select("exec pro_energy_sum2 #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proEnergySum2(@Param("curDate") String curDate);

    //汇总维保量
    @Select("exec pro_maintain_sum #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proMaintainSum(@Param("curDate") String curDate);

    @Select("exec pro_analysis_month #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proAnalysisMonth(@Param("curDate") String curDate);

    @Select("exec pro_analysis_year #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proAnalysisYear(@Param("curDate") String curDate);

    @Select("exec pro_alarm_manage #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proAlarmManage(@Param("curDate") String curDate);

    @Select("exec pro_alarm_info_sum #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proAlarmInfoSum(@Param("curDate") String curDate);

    //设备状态汇总
    @Select("exec pro_device_state #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proDeviceState(@Param("curDate") String curDate);

    @Select("exec pro_deal_data ")
    @Options(statementType = StatementType.CALLABLE)
    void dealData();

    @Delete("delete from chillers_data_history where convert(varchar(7),collection_time,23) = convert(varchar(7),dateadd(month,-3,getdate()),23)")
    void deleteChillersDataHistory();

    @Delete("delete from data_history where convert(varchar(7),cur_date,23) = convert(varchar(7),dateadd(month,-12,getdate()),23)")
    void deleteDataHistory();

    //查询学校名称
    @Select("select customName from  SysParam  ")
    String customName();

    //判断网关在线状态
    @Select("exec pro_gatewayState ")
    @Options(statementType = StatementType.CALLABLE)
    void proGatewayState();

    //统计周、月热泵运行时长
    @Select("exec pro_TotalPumpMinutes #{curDate,jdbcType=VARCHAR,mode=IN} ")
    @Options(statementType = StatementType.CALLABLE)
    void proTotalPumpMinutes(@Param("curDate") String curDate);

}
