package com.mh.user.mapper;

import com.mh.user.entity.DeviceCodeParamEntity;
import com.mh.user.entity.DeviceInstallEntity;
import com.mh.user.entity.OrderMessageEntity;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface DeviceCodeParamMapper {

    //插入指令参数
    @Insert("insert into device_code_param(device_addr,device_name,device_type,data_com,baudrate,brand,fun_code,register_addr,create_time)" +
            "values(#{deviceAddr},#{deviceName},#{deviceType},#{dataCom},#{baudrate},#{brand},#{funCode},#{registerAddr},getDate())")
    void insertDeviceCodeParam(DeviceCodeParamEntity deviceCodeParamEntity);

    //查询指令参数,传入IP和端口
    @Results(id="rs", value = {
            @Result(property="id",column="id"),
            @Result(property="deviceAddr",column="device_addr"),
            @Result(property="deviceType",column="device_type"),
            @Result(property="dataCom",column="data_com"),
            @Result(property="baudrate",column="baudrate"),
            @Result(property ="brand",column ="brand"),
            @Result(property ="funCode",column ="fun_code"),
            @Result(property ="registerAddr",column ="register_addr"),
            @Result(property ="deviceName",column ="device_name"),
            @Result(property ="createTime",column ="create_time"),
            @Result(property ="buildingId",column ="building_id")
    })
    @Select("select t1.* from  device_code_param t1 join gateway_manage t2  on t1.data_com=t2.data_com where t2.gateway_ip=#{gatewayIP}  and  t2.gateway_port=#{gatewayPort} ")
    List<DeviceCodeParamEntity> queryCodeParam(@Param("gatewayIP") String gatewayIP, @Param("gatewayPort") String gatewayPort);

    //查询指令参数,传入串口
    @ResultMap("rs")
    @Select("select t1.* from  device_code_param t1 join gateway_manage t2  on t1.data_com=t2.data_com  where t2.data_com=#{comName}")
    List<DeviceCodeParamEntity> queryCodeParam2(@Param("comName") String comName);

    //查询所有指令参数
    @ResultMap("rs")
    @Select("select * from  device_code_param  " +
//            "<where>" +
//            "<if test='thread != null and thread != \"\"'>" +
//            " and thread=#{thread} " +
//            "</if>" +
//            "</where>" +
            "order by data_com,device_type")
    //@Select("select * from  device_code_param  order by data_com,device_type ")
//    @Select("select * from  device_code_param  order by device_type ")
    List<DeviceCodeParamEntity> queryCodeParam3(@Param("thread") String thread);

    //查询所有指令参数
    @ResultMap("rs")
    @Select("select * from  device_code_param2  " +
//            "<where>" +
//            "<if test='thread != null and thread != \"\"'>" +
//            " and thread=#{thread} " +
//            "</if>" +
//            "</where>" +
            "order by data_com,device_type")
    //@Select("select * from  device_code_param2  order by data_com,device_type ")
//    @Select("select * from  device_code_param2  order by device_type ")
    List<DeviceCodeParamEntity> queryCodeParam4(@Param("thread") String thread);

    //查询所有指令参数
    @ResultMap("rs")
    @Select("select * from  device_code_param3 " +
//            "<where>" +
//            "<if test='thread != null and thread != \"\"'>" +
//            " and thread=#{thread} " +
//            "</if>" +
//            "</where>" +
            " order by data_com,device_type")
    //@Select("select * from  device_code_param3  order by data_com,device_type")
//    @Select("select * from  device_code_param3  order by device_type ")
    List<DeviceCodeParamEntity> queryCodeParam5(@Param("thread") String thread);

    //查询记录数
    @Select("select  count(*) from device_code_param ")
    int queryCount();

    //查询记录数
    @Select("select  count(*) from device_code_param2 ")
    int queryCount2();

    //查询记录数
    @Select("select  count(*) from device_code_param3 ")
    int queryCount3();

    // 批量插入生成指令参数入数据库
    @Insert("<script>" +
            "insert into device_code_param(" +
            "device_addr, " +
            "device_name, " +
            "device_type, " +
            "data_com, " +
            "baudrate, " +
            "brand, " +
            "fun_code, " +
            "register_addr," +
            "create_time," +
            "building_id," +
            "parity," +
            "thread" +
            ")" +
            "values " +
            "<foreach collection='deviceCodeParamEntityList' item='item' separator=','>" +
            "(#{item.deviceAddr},#{item.deviceName},#{item.deviceType},#{item.dataCom},#{item.baudrate},#{item.brand},#{item.funCode},#{item.registerAddr},getDate(),#{item.buildingId},#{item.parity},#{item.thread})" +
            "</foreach>" +
            "</script>")
    void insertDeviceCodeParamList(@Param("deviceCodeParamEntityList") List<DeviceCodeParamEntity> deviceCodeParamEntityList);

    // 批量插入生成指令参数入数据库
    @Insert("<script>" +
            "insert into device_code_param2(" +
            "device_addr, " +
            "device_name, " +
            "device_type, " +
            "data_com, " +
            "baudrate, " +
            "brand, " +
            "fun_code, " +
            "register_addr," +
            "create_time," +
            "building_id," +
            "parity," +
            "thread" +
            ")" +
            "values " +
            "<foreach collection='deviceCodeParamEntityList' item='item' separator=','>" +
            "(#{item.deviceAddr},#{item.deviceName},#{item.deviceType},#{item.dataCom},#{item.baudrate},#{item.brand},#{item.funCode},#{item.registerAddr},getDate(),#{item.buildingId},#{item.parity},#{item.thread})" +
            "</foreach>" +
            "</script>")
    void insertDeviceCodeParamList2(@Param("deviceCodeParamEntityList") List<DeviceCodeParamEntity> deviceCodeParamEntityList);

    // 批量插入生成指令参数入数据库
    @Insert("<script>" +
            "insert into device_code_param3(" +
            "device_addr, " +
            "device_name, " +
            "device_type, " +
            "data_com, " +
            "baudrate, " +
            "brand, " +
            "fun_code, " +
            "register_addr," +
            "create_time," +
            "building_id," +
            "parity," +
            "thread" +
            ")" +
            "values " +
            "<foreach collection='deviceCodeParamEntityList' item='item' separator=','>" +
            "(#{item.deviceAddr},#{item.deviceName},#{item.deviceType},#{item.dataCom},#{item.baudrate},#{item.brand},#{item.funCode},#{item.registerAddr},getDate(),#{item.buildingId},#{item.parity},#{item.thread})" +
            "</foreach>" +
            "</script>")
    void insertDeviceCodeParamList3(@Param("deviceCodeParamEntityList") List<DeviceCodeParamEntity> deviceCodeParamEntityList);

    //查询插入压变、温控
        @Insert("insert into device_code_param(device_addr,device_name,device_type,data_com,baudrate,parity,brand,create_time,building_id) select device_addr,device_name,device_type,data_com,baudrate,parity,brand,getDate(),building_id from  device_install  where  device_type='压变'  or device_type='温控'  or device_type='温度变送器' ")
    void selectInsertDeviceCodeParam();

    //查询插入水、电表、状态检测
    @Insert("insert into device_code_param2(device_addr,device_name,device_type,data_com,baudrate,parity,brand,create_time,building_id) select device_addr,device_name,device_type,data_com,baudrate,parity,brand,getDate(),building_id from  device_install  where  device_type='电表' or device_type='水表' or  device_type='状态检测' or  device_type='热泵状态' ")
    void selectInsertDeviceCodeParam2();

    //查询插入水位开关
    @Insert("insert into device_code_param3(device_addr,device_name,device_type,data_com,baudrate,parity,brand,create_time,building_id) select device_addr,device_name,device_type,data_com,baudrate,parity,brand,getDate(),building_id from  device_install  where  device_type='水位开关'  ")
    void selectInsertDeviceCodeParam3();

    @Delete("delete from device_code_param " +
            " where device_addr=#{deviceAddr} and device_type = #{deviceType} and data_com = #{dataCom} and building_id = #{buildingId}")
    void deleteParamCode1(DeviceInstallEntity oldEntity);

    @Delete("delete from device_code_param2 " +
            " where device_addr=#{deviceAddr} and device_type = #{deviceType} and data_com = #{dataCom} and building_id = #{buildingId}")
    void deleteParamCode2(DeviceInstallEntity oldEntity);

    @Delete("delete from device_code_param3 " +
            " where device_addr=#{deviceAddr} and device_type = #{deviceType} and data_com = #{dataCom} and building_id = #{buildingId}")
    void deleteParamCode3(DeviceInstallEntity oldEntity);
}
