package com.mh.user.mapper;

import com.mh.user.dto.DeviceMessageDTO;
import com.mh.user.dto.DisplayBoxDataDTO;
import org.apache.ibatis.annotations.*;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ： 设备数据显示持久化层
 * @updateTime 2020-05-29
 * @throws ：
 */
@Component
@Mapper
public interface DeviceDisplayMapper {

    // deviceType: 设备类型（host：主机 pump：泵 tower：塔）type: 1(查询阴影值)，0(查询数据框内容)
    @Select("select title, sec_content1, sec_content2, first_div_class, device_id, grade from table_display_box_data " +
            " where device_type = #{deviceType} and query_type = #{type}")
    @Results({
            @Result(column = "title", property = "title"),
            @Result(column = "sec_content1", property = "secContent1"),
            @Result(column = "sec_content2", property = "secContent2"),
            @Result(column = "first_div_class", property = "firstDivClass"),
            @Result(column = "device_id", property = "deviceId"),
            @Result(column = "grade", property = "grade")
    })
    List<DisplayBoxDataDTO> deviceDisplayBoxData(@Param("deviceType") String deviceType, @Param("type") String type);

    // 设备信息状态显示
    @Select("select label, span_length, open_state, device_id, grade from table_device_status where device_type = #{deviceType}")
    @Results({
            @Result(column = "label", property = "label"),
            @Result(column = "span_length", property = "spanLength"),
            @Result(column = "open_state", property = "openState"),
            @Result(column = "device_id", property = "deviceId"),
            @Result(column = "grade", property = "grade")
    })
    List<DeviceMessageDTO> queryDeviceStatus(@Param("deviceType") String deviceType);

}
