package com.mh.user.mapper;

import com.mh.user.entity.ExceptionEntity;
import com.mh.user.entity.ExceptionTableData;
import com.mh.user.provide.ExceptionProvider;
import org.apache.ibatis.annotations.*;

import java.util.List;

/**
 * @author ljf
 * @title ： 异常接口
 * @description ：
 * @updateTime 2020-07-31
 * @throws ：
 */
@Mapper
public interface ExceptionMapper {

    @SelectProvider(type = ExceptionProvider.class, method = "queryException")
    @Results({
            @Result(column = "id", property = "deviceId"),
            @Result(column = "register_name", property = "deviceName"),
            @Result(column = "last_value", property = "info"),
            @Result(column = "create_time", property = "timeStamp"),
            @Result(column = "remark", property = "remark"),
            @Result(column = "state", property = "process")
    })
    List<ExceptionTableData> queryException(ExceptionEntity exceptionEntity);

    @SelectProvider(type = ExceptionProvider.class, method = "queryExceptionTotal")
    int queryExceptionTotal(ExceptionEntity exceptionEntity);

    @Update("update device_exception_alarm set state = #{process}, remark = #{remark} where id = #{deviceId}")
    int updateException(ExceptionTableData exceptionTableData);

}
