package com.mh.user.mapper;

import com.mh.user.entity.AlarmInfoSumEntity;
import com.mh.user.entity.DeviceStateEntity;
import com.mh.user.entity.EnergySumEntity;
import com.mh.user.entity.MaintainSumEntity;
import org.apache.ibatis.annotations.*;

@Mapper
public interface SummaryMapper {


    @Results(value = {
            @Result(property="curDate",column="cur_date"),
            @Result(property="deviceNum",column="device_num"),
            @Result(property="electNum",column="elect_num"),
            @Result(property="waterNum",column="water_num"),
            @Result(property="pumpNum",column="pump_num"),
            @Result(property ="PressureNum",column ="Pressure_num"),
            @Result(property ="runNum",column ="run_num"),
            @Result(property ="lastRunNum",column ="last_run_num"),
            @Result(property="runP",column="run_p"),
            @Result(property="onlineNum",column="online_num"),
            @Result(property="offlineNum",column="offline_num"),
            @Result(property="faultNum",column="fault_num"),
            @Result(property="lastFaultNum",column="last_fault_num"),
            @Result(property="faultP",column="fault_p"),
            @Result(property="pumpOnline",column="pump_online")
    })
    //查询设备状态汇总
    @Select("select top 1* from  device_state order by cur_date desc")
    DeviceStateEntity queryDeviceState();

    //查询日汇总
    @Results(id="rs", value = {
            @Result(property="curDate",column="cur_date"),
            @Result(property="buildingId",column="building_id"),
            @Result(property="fillWater",column="fill_water"),
            @Result(property="fillWaterP",column="fill_water_p"),
            @Result(property ="waterValue",column ="water_value"),
            @Result(property ="waterP",column ="water_p"),
            @Result(property ="electValue",column ="elect_value"),
            @Result(property="electP",column="elect_p"),
            @Result(property="electWater",column="elect_water"),
            @Result(property="electWaterP",column="elect_water_p")
    })
    @Select("select  *  from  energy_day_sum  where  building_id=#{buildingId} and cur_date=#{curDate} ")
    EnergySumEntity queryEnergyDaySum(@Param("buildingId") String buildingId,@Param("curDate") String curDate);

    //查询月汇总
    @ResultMap("rs")
    @Select("select  *  from  energy_month_sum  where  building_id=#{buildingId} and cur_date=#{curDate} ")
    EnergySumEntity queryEnergyMonthSum(@Param("buildingId") String buildingId,@Param("curDate") String curDate);

    //查询年汇总
    @ResultMap("rs")
    @Select("select  *  from  energy_year_sum  where  building_id=#{buildingId} and cur_date=#{curDate} ")
    EnergySumEntity queryEnergyYearSum(@Param("buildingId") String buildingId,@Param("curDate") String curDate);

    //查询维修量汇总
    @Results(value = {
            @Result(property="curDate",column="cur_date"),
            @Result(property="buildingId",column="building_id"),
            @Result(property="dayNum",column="day_num"),
            @Result(property="dayP",column="day_p"),
            @Result(property ="weekNum",column ="week_num"),
            @Result(property ="weekP",column ="week_p"),
            @Result(property ="monthNum",column ="month_num"),
            @Result(property="monthP",column="month_p"),
            @Result(property="yearNum",column="year_num"),
            @Result(property="yearP",column="year_p")
    })
    @Select("select * from maintain_sum  where  building_id=#{buildingId} and cur_date=#{curDate}")
    MaintainSumEntity queryMaintainSum(@Param("buildingId") String buildingId,@Param("curDate") String curDate);

    //警报管理汇总查询
    @Results(value = {
            @Result(property="curDate",column="cur_date"),
            @Result(property="buildingId",column="building_id"),
            @Result(property="deviceNum",column="device_num"),
            @Result(property="faultNum",column="fault_num"),
            @Result(property ="waterLevel",column ="water_level"),
            @Result(property ="waterLevelNum",column ="water_level_num"),
            @Result(property ="electWater",column ="elect_water"),
            @Result(property="electWaterNum",column="elect_water_num"),
            @Result(property ="waterTemp",column ="water_temp"),
            @Result(property="waterTempNum",column="water_temp_num")
    })
    @Select("select * from  alarm_info_sum ")
    AlarmInfoSumEntity queryAlarmInfoSum(@Param("buildingId") String buildingId, @Param("curDate") String curDate);

}
