package com.mh.user.mapper;

import com.mh.user.entity.SysParamEntity;
import com.mh.user.mapper.provider.NowDataProvider;
import com.mh.user.mapper.provider.SysLogProvider;
import com.mh.user.model.SysLog;
import org.apache.ibatis.annotations.*;

import java.util.List;

/**
 * author: ljf
 * desc: 系统日志Mapper
 */
@Mapper
public interface SysLogMapper {
    int deleteByPrimaryKey(Long id);

    int insert(SysLog record);

    int insertSelective(SysLog record);

    SysLog selectByPrimaryKey(Long id);

    int updateByPrimaryKeySelective(SysLog record);

    int updateByPrimaryKey(SysLog record);

    List<SysLog> findPage();

    @SelectProvider(type = SysLogProvider.class,method = "findLogs")
    @Results(value = {
            @Result(property="createBy",column="create_by"),
            @Result(property="createTime",column="create_time"),
            @Result(property="ip",column="ip"),
            @Result(property ="lastUpdateBy",column ="last_update_by"),
            @Result(property="lastUpdateTime",column="last_update_time"),
            @Result(property ="method",column ="method"),
            @Result(property="operation",column="operation"),
            @Result(property ="params",column ="params"),
            @Result(property ="time",column ="time"),
            @Result(property ="userName",column ="user_name"),
            @Result(property ="loginTime",column ="login_time"),
            @Result(property ="loginState",column ="login_state"),
            @Result(property ="optDesc",column ="opt_desc")
    })
    List<SysLog> findLogs(@Param("userName") String userName,@Param("page") int page,@Param("limit") int limit );

    @SelectProvider(type = SysLogProvider.class,method = "findCount")
    int findCount(@Param("userName") String userName,@Param("page") int page,@Param("limit") int limit );

    //查询日志详情
    @Select("select * from  sys_log  where  id=#{id}")
    SysLog logInfo(@Param("id") int id);

    List<SysLog> findPageByUserName(@Param(value = "userName") String userName);

    @Select("select * from  SysParam ")
    SysParamEntity selectSysParam();
}
