package com.mh.user.mapper;

import com.mh.user.mapper.provider.SysRoleProvider;
import com.mh.user.mapper.provider.SysUserProvider;
import com.mh.user.model.SysRole;
import org.apache.ibatis.annotations.*;

import java.util.List;

/**
 * author: ljf
 * desc: 系统角色Mapper
 */
@Mapper
public interface SysRoleMapper {
    int deleteByPrimaryKey(Long id);

    int insert(SysRole record);

    int insertSelective(SysRole record);

    SysRole selectByPrimaryKey(Long id);

    int updateByPrimaryKeySelective(SysRole record);

    int updateByPrimaryKey(SysRole record);

    List<SysRole> findPage();

	List<SysRole> findAll();

	List<SysRole> findPageByName(@Param(value = "roleName") String name);

	List<SysRole> findByName(@Param(value = "roleName") String name);

    @Results(id="rs",value = {
            @Result(property="id",column="id"),
            @Result(property="name",column="role_name"),
            @Result(property="createBy",column="create_by"),
            @Result(property="createTime",column="create_time"),
            @Result(property ="lastUpdateBy",column ="last_update_by"),
            @Result(property ="lastUpdateTime",column ="last_update_time"),
            @Result(property="delFlag",column="del_flag"),
            @Result(property="remarks",column="remarks")
    })
    @Select("select * from sys_role where  role_name=#{roleName}")
    SysRole findId(@Param(value = "roleName") String name);

    //查询所有角色
    @ResultMap("rs")
    @SelectProvider(type = SysRoleProvider.class,method = "queryRoles")
    //@Select("select * from (select *,ROW_NUMBER() over(order by id) as rn from sys_role  where 1=1 )T where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}")
    List<SysRole> queryRoles(@Param("roleName") String roleName,@Param(value = "page") int page,@Param(value = "limit") int limit);

    //查询所有记录数
    //@Select("select count(*) from (select *,ROW_NUMBER() over(order by id) as rn from sys_role  where 1=1)T ")
    @SelectProvider(type = SysRoleProvider.class,method = "getCount")
    int getCount(@Param("roleName") String roleName,@Param(value = "page") int page,@Param(value = "limit") int limit);

}
