package com.mh.user.mapper;

import com.mh.user.entity.UseForecastEntity;
import com.mh.user.mapper.provider.UseForecastProvider;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface UseForecastMapper {

    //插入记录
    @Insert("insert into use_forecast(tank_id,tank_name,wt_level_set,wt_temp_set,tank_level,tank_temp,env_temp,start_datetime,building_id) values (" +
            " #{tankId},#{tankName},#{wtLevelSet},#{wtTempSet},#{tankLevel},#{tankTemp},#{envTemp},#{startDatetime},#{buildingId})")
    void saveUseForecast(UseForecastEntity useForecastEntity);

    //修改记录
    @Update("<script>" +
            "  update use_forecast set  " +
            "  <if test='tankName!=null'>  tank_name = #{tankName} </if>" +
            "  <if test='wtLevelSet!=null'> , wt_level_set = #{wtLevelSet} </if>" +
            "  <if test='wtTempSet!=null'> , wt_temp_set = #{wtTempSet} </if>" +
            "  <if test='tankLevel!=null'> , tank_level = #{tankLevel} </if>" +
            "  <if test='tankTemp!=null'> , tank_temp = #{tankTemp} </if>" +
            "  <if test='envTemp!=null'> , env_temp = #{envTemp} </if>" +
            "  <if test='startDatetime!=null'> , start_datetime = #{startDatetime} </if>" +
            "  <if test='buildingId!=null'> , building_id = #{buildingId} </if>" +
            "   where tank_id = #{tankId} " +
            "</script>")
    void updateUseForecast(UseForecastEntity useForecastEntity);

    // 查询
    @Results(value = {
            @Result(property="tankId",column="tank_id"),
            @Result(property="tankName",column="tank_name"),
            @Result(property="wtLevelSet",column="wt_level_set"),
            @Result(property ="wtTempSet",column ="wt_temp_set"),
            @Result(property ="tankLevel",column ="tank_level"),
            @Result(property="tankTemp",column="tank_temp"),
            @Result(property="envTemp",column="env_temp"),
            @Result(property="startDatetime",column="start_datetime"),
            @Result(property="buildingId",column="building_id")
    })
    @SelectProvider(type = UseForecastProvider.class,method = "queryUseForecast")
    List<UseForecastEntity> queryUseForecast(@Param("buildingId") String buildingId, @Param("tankId") String tankId,@Param("curDate") String curDate, @Param("page") int page, @Param("limit") int limit);

    // 查询记录数
    @SelectProvider(type = UseForecastProvider.class,method = "getCount")
    int getCount(@Param("buildingId") String buildingId,@Param("tankId") String tankId,@Param("curDate") String curDate,@Param("page") int page, @Param("limit") int limit);

}
