package com.mh.user.mapper.provider;

public class AlarmInfoProvider {

    public String queryAlarmInfo(String alarmTime,String alarmType,String buildingId,String dealState, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from Alarm_info  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (alarmType != null && !alarmType.equals("")){
            sql.append(" AND alarm_type = #{alarmType} ");
        }
        if (alarmTime!= null && !alarmTime.equals("")) {
            sql.append(" AND CONVERT(varchar(10),alarm_time,121)=#{alarmTime} ");
        }
        if (dealState!= null && !dealState.equals("")) {
            sql.append(" AND deal_state=#{dealState} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) T join building T1  ON T.building_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.alarm_time desc ");
        } else if (page == 0){
            sql.append(" ) T order by T.alarm_time desc ");
        }

//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询记录数
    public String getAlarmInfoCount(String alarmTime,String alarmType,String buildingId,String dealState, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from  Alarm_info " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (alarmType != null && !alarmType.equals("")){
            sql.append(" AND alarm_type = #{alarmType} ");
        }
        if (alarmTime!= null && !alarmTime.equals("")) {
            sql.append(" AND CONVERT(varchar(10),alarm_time,121)=#{alarmTime} ");
        }
        if (dealState!= null && !dealState.equals("")) {
            sql.append(" AND deal_state=#{dealState} ");
        }
        sql.append(" ) T  join building T1  ON T.building_id=T1.id ");

//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String queryAlarmValueSet(String buildingId,String itemType,int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from alarm_value_set  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (itemType != null && !itemType.equals("")){
            sql.append(" AND itemType = #{itemType} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) T join building T1  ON T.building_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}");
        } else if (page == 0){
            sql.append(" ) T ");
        }

//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询记录数
    public String getAlarmValueSetCount(String buildingId,String itemType){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from  alarm_value_set " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (itemType != null && !itemType.equals("")){
            sql.append(" AND itemType = #{itemType} ");
        }
        sql.append(" ) T  join building T1  ON T.building_id=T1.id ");

//        System.out.println(sql.toString());
        return sql.toString();
    }


}
