package com.mh.user.mapper.provider;

public class DataResultProvider {

    public String queryDataResult(String buildingId,String startDate,String endDate,String deviceType, int page, int limit){
        StringBuffer sql = new StringBuffer("");

        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by cur_date desc) as rn from data_result  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)>=#{startDate} ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)<=#{endDate} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND device_type = #{deviceType} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) T  join building T1  ON T.building_id=T1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date desc ");
        } else if (page == 0){
            sql.append(" ) T order by T.cur_date desc ");
        }

//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询记录数
    public String getDataResultCount(String buildingId,String startDate,String endDate,String deviceType, int page, int limit){
        StringBuffer sql = new StringBuffer("");

        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by cur_date desc) as rn from  data_result " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)>=#{startDate} ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)<=#{endDate} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND device_type = #{deviceType} ");
        }
        sql.append(" ) T  join building T1  ON T.building_id=T1.id ");

//        System.out.println(sql.toString());
        return sql.toString();
    }
}
