package com.mh.user.mapper.provider;

public class NowDataProvider {

    //查询楼栋水箱温度
    public String queryHistoryData(String curDate,String buildingId,String pumpId,String tankId, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from history_data  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (pumpId != null && !pumpId.equals("")){
            sql.append(" AND pump_id = #{pumpId} ");
        }
        if (tankId != null && !tankId.equals("")){
            sql.append(" AND tank_id = #{tankId} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)=#{curDate} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) T join building T1  ON T.building_id=T1.id where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}");
        } else if (page == 0){
            sql.append(" ) T ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询楼栋水箱温度记录数
    public String getHistoryDataCount(String curDate,String buildingId,String pumpId,String tankId, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from  history_data " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (pumpId != null && !pumpId.equals("")){
            sql.append(" AND pump_id = #{pumpId} ");
        }
        if (tankId != null && !tankId.equals("")){
            sql.append(" AND tank_id = #{tankId} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND  convert(varchar(10),cur_date,121)=#{curDate} ");
        }
        sql.append(" ) T  join building T1  ON T.building_id=T1.id ");
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //从history_data表查询水位,改为从waterLevel表拿数据
    public String queryWaterLevel(String curDate,String buildingID, int page, int limit){
//        StringBuffer sql = new StringBuffer("");
//        sql.append("select * from (select *,ROW_NUMBER() over(order by cur_date) as rn from (" +
//                   " select DISTINCT t1.building_id,t1.cur_date,t1.water_level,t2.building_name from history_data t1  join building t2 on t1.building_id=t2.id  " +
//                   " where 1=1 ");
//        if (buildingID != null && !buildingID.equals("")){
//            sql.append(" AND t1.building_id = #{buildingID} ");
//        }
//        if (curDate!= null && !curDate.equals("")) {
//            sql.append(" AND convert(varchar(10),t1.cur_date,121)=#{curDate}  ");
//        }
//        if ((page != 0) && (limit != 0)){
//            sql.append(" ) T )TT  where TT.rn>(#{page}-1)*#{limit} and TT.rn<=#{page}*#{limit} order by TT.cur_date ");
//        } else if (page == 0){
//            sql.append(" ) T )TT  order by TT.cur_date ");
//        }
        StringBuffer sql = new StringBuffer("");
        sql.append("select T.* from (select *,ROW_NUMBER() over(order by cur_date) as rn from waterLevel" +
                " where 1=1 ");
        if (buildingID != null && !buildingID.equals("")){
            sql.append(" AND building_id = #{buildingID} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)=left(#{curDate},10)  ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) T join building t1 on T.building_id=t1.id  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date,t1.sort ");
        } else if (page == 0){
            sql.append(" ) T join building t1 on T.building_id=t1.id  order by T.cur_date,t1.sort ");
        }
////        System.out.println(sql.toString());
        return sql.toString();
    }

    //从history_data表查询水位记录数，改为从waterLevel表拿数据
    public String getWaterLevelCount(String curDate,String buildingID){
//        StringBuffer sql = new StringBuffer("");
//        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by cur_date) as rn from (" +
//                " select DISTINCT t1.building_id,t1.cur_date,t1.water_level,t2.building_name from history_data t1  join building t2 on t1.building_id=t2.id  " +
//                " where 1=1 ");
//        if (buildingID != null && !buildingID.equals("")){
//            sql.append(" AND t1.building_id = #{buildingID} ");
//        }
//        if (curDate!= null && !curDate.equals("")) {
//            sql.append(" AND convert(varchar(10),t1.cur_date,121)=#{curDate}  ");
//        }
//        sql.append(" ) T )TT ");
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by cur_date) as rn from waterLevel" +
                " where 1=1 ");
        if (buildingID != null && !buildingID.equals("")){
            sql.append(" AND building_id = #{buildingID} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)=left(#{curDate},10)  ");
        }
        sql.append(" ) T join building t1 on T.building_id=t1.id  ");
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询每天楼栋水位变化
    public String queryBuildWaterLevel(String curDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select top 1000 * ,ROW_NUMBER() over(order by cur_date desc) as rn from (select top 1000 t1.*,t2.sort " +
                " from  waterLevel t1 join building t2 on t1.building_id=t2.id  order by  t1.cur_date desc,t2.sort) t3  where  1=1 ");
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(10),t3.cur_date,121)=left(#{curDate},10)  ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) t4  where t4.rn>(#{page}-1)*#{limit} and t4.rn<=#{page}*#{limit} ");
        } else if (page == 0){
            sql.append(" ) t4 ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //从history_data查询水温
    public String queryWaterTemp(String buildingID,String curDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by cur_date) as rn from (" +
                   "select t1.*,t2.building_name from WaterTemp t1 join building t2 on t1.building_id=t2.id "+
                   " where 1=1 ");
        if (buildingID != null && !buildingID.equals("")){
            sql.append(" AND t1.building_id= #{buildingID} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(10),t1.cur_date,121)=#{curDate}  ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" )T )TT  where TT.rn>(#{page}-1)*#{limit} and TT.rn<=#{page}*#{limit} order by TT.pump_id ");
        } else if (page == 0){
            sql.append(" )T )TT  order by TT.pump_id ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //从history_data查询水温记录数
    public String queryWaterTempCount(String buildingID,String curDate){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by cur_date) as rn from (" +
                "select t1.*,t2.building_name from WaterTemp t1 join building t2 on t1.building_id=t2.id "+
                " where 1=1 ");
        if (buildingID != null && !buildingID.equals("")){
            sql.append(" AND t1.building_id= #{buildingID} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(10),t1.cur_date,121)=#{curDate}  ");
        }
        sql.append(" ) T )TT ");
//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String queryWaterTemp2(String curDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select top 1000 * from (select *,ROW_NUMBER() over(order by cur_date) as rn from (" +
                "select top 1000 t1.cur_date,t1.building_id,t2.building_name,t2.sort,convert(decimal(8,1),AVG(convert(float,t1.temp00)))as temp00," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp02)))as temp02," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp06)))as temp06," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp08)))as temp08,convert(decimal(8,1),AVG(convert(float,t1.temp11)))as temp11," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp13)))as temp13,convert(decimal(8,1),AVG(convert(float,t1.temp15)))as temp15," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp16)))as temp16,convert(decimal(8,1),AVG(convert(float,t1.temp17)))as temp17," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp18)))as temp18,convert(decimal(8,1),AVG(convert(float,t1.temp19)))as temp19," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp20)))as temp20,convert(decimal(8,1),AVG(convert(float,t1.temp21)))as temp21," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp22)))as temp22,convert(decimal(8,1),AVG(convert(float,t1.temp23)))as temp23 " +
                " from WaterTemp t1 join building t2 on t1.building_id=t2.id where 1=1 ");
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(10),t1.cur_date,121)=#{curDate}  group by t1.building_id,t2.building_name,t2.sort,t1.cur_date order by t2.sort ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" )T )TT  where TT.rn>(#{page}-1)*#{limit} and TT.rn<=#{page}*#{limit} order by TT.cur_date desc ");
        } else if (page == 0){
            sql.append(" )T )TT  order by TT.cur_date desc ");
        }
        return sql.toString();
    }

    //从history_data查询水温记录数
    public String queryWaterTempCount2(String curDate){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by cur_date) as rn from (" +
                "select t1.cur_date,t1.building_id,t2.building_name,t2.sort,convert(decimal(8,1),AVG(convert(float,t1.temp00)))as temp00," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp02)))as temp02,convert(decimal(8,1),AVG(convert(float,t1.temp06)))as temp06," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp08)))as temp08,convert(decimal(8,1),AVG(convert(float,t1.temp11)))as temp11," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp13)))as temp13,convert(decimal(8,1),AVG(convert(float,t1.temp15)))as temp15," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp16)))as temp16,convert(decimal(8,1),AVG(convert(float,t1.temp17)))as temp17," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp18)))as temp18,convert(decimal(8,1),AVG(convert(float,t1.temp19)))as temp19," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp20)))as temp20,convert(decimal(8,1),AVG(convert(float,t1.temp21)))as temp21," +
                "convert(decimal(8,1),AVG(convert(float,t1.temp22)))as temp22,convert(decimal(8,1),AVG(convert(float,t1.temp23)))as temp23 " +
                " from WaterTemp t1 join building t2 on t1.building_id=t2.id where 1=1 ");
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(10),t1.cur_date,121)=#{curDate}  group by t1.building_id,t2.building_name,t2.sort,t1.cur_date ");
        }
        sql.append(" )T )TT ");
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //从history_data表按时间点查询水位
    public String queryWaterLevelByTime(String curDate, int page, int limit){
//        StringBuffer sql = new StringBuffer("");
//        sql.append("select * from (select *,ROW_NUMBER() over(order by cur_date) as rn from history_data " +
//                   " where 1=1 ");
//        if (curDate!= null && !curDate.equals("")) {
//            sql.append(" AND convert(varchar(13),cur_date,121)=#{curDate}  ");
//        }
//        if ((page != 0) && (limit != 0)){
//            sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
//        } else if (page == 0){
//            sql.append(" )T  order by T.cur_date ");
//        }
//        System.out.println(sql.toString());
//        return sql.toString();
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by cur_date) as rn from (" +
                " select DISTINCT t1.building_id,t1.cur_date,t1.water_level,t2.building_name from history_data t1  join building t2 on t1.building_id=t2.id  " +
                " where 1=1 ");
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(13),t1.cur_date,121)=#{curDate}  ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) T )TT  where TT.rn>(#{page}-1)*#{limit} and TT.rn<=#{page}*#{limit} order by TT.cur_date ");
        } else if (page == 0){
            sql.append(" ) T )TT  order by TT.cur_date ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //从history_data表按时间点查询水位记录数
    public String waterLevelByTimeCount(String curDate){
        StringBuffer sql = new StringBuffer("");
//        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by cur_date) as rn from  history_data" +
//                  " where 1=1 ");
//        if (curDate!= null && !curDate.equals("")) {
//            sql.append(" AND convert(varchar(13),cur_date,121)=#{curDate}  ");
//        }
//        sql.append(" )T ");
//        System.out.println(sql.toString());
//        return sql.toString();
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by cur_date) as rn from (" +
                " select DISTINCT t1.building_id,t1.cur_date,t1.water_level,t2.building_name from history_data t1  join building t2 on t1.building_id=t2.id  " +
                " where 1=1 ");
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND convert(varchar(13),t1.cur_date,121)=#{curDate}  ");
        }
        sql.append(" ) T )TT ");
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询热泵时长记录
    public String pumpMinutes(String startDate,String endDate,String buildingId,String pumpId,int page,int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by cur_date) as rn from pump_minutes " +
                " where 1=1 ");
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)>=#{startDate}  ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)<=#{endDate}  ");
        }
        if (buildingId!= null && !buildingId.equals("")) {
            sql.append(" AND building_id=#{buildingId}  ");
        }
        if (pumpId!= null && !pumpId.equals("")) {
            sql.append(" AND pump_id=#{pumpId} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" )T where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
        } else if (page == 0){
            sql.append(" )T  order by T.cur_date ");
        }
        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询热泵时长记录
    public String pumpMinutesCount(String startDate,String endDate,String buildingId,String pumpId){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by cur_date) as rn from pump_minutes " +
                " where 1=1 ");
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)>=#{startDate} ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)<=#{endDate} ");
        }
        if (buildingId!= null && !buildingId.equals("")) {
            sql.append(" AND building_id=#{buildingId} ");
        }
        if (pumpId!= null && !pumpId.equals("")) {
            sql.append(" AND pump_id=#{pumpId} ");
        }
        sql.append(" )T");
        //System.out.println(sql.toString());
        return sql.toString();
    }

    //查询热泵时长记录
    public String pumpWeekMinutes(String startDate,String endDate,String buildingId,String pumpId,int page,int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by cur_date) as rn from pump_week_minutes " +
                " where 1=1 ");
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND cur_date>=#{startDate}  ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND cur_date<=#{endDate}  ");
        }
        if (buildingId!= null && !buildingId.equals("")) {
            sql.append(" AND building_id=#{buildingId}  ");
        }
        if (pumpId!= null && !pumpId.equals("")) {
            sql.append(" AND pump_id=#{pumpId}  ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
        } else if (page == 0){
            sql.append(" )T  order by T.cur_date ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询热泵时长记录
    public String pumpWeekMinutesCount(String startDate,String endDate,String buildingId,String pumpId){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by cur_date) as rn from pump_week_minutes " +
                " where 1=1 ");
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)>=#{startDate} ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND convert(varchar(10),cur_date,121)<=#{endDate} ");
        }
        if (buildingId!= null && !buildingId.equals("")) {
            sql.append(" AND building_id=#{buildingId}  ");
        }
        if (pumpId!= null && !pumpId.equals("")) {
            sql.append(" AND pump_id=#{pumpId} ");
        }
        sql.append(" )T");
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询热泵时长记录
    public String pumpMonthMinutes(String startDate,String endDate,String buildingId,String pumpId,int page,int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (select *,ROW_NUMBER() over(order by cur_date) as rn from pump_month_minutes " +
                " where 1=1 ");
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND cur_date>=#{startDate}  ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND cur_date<=#{endDate}  ");
        }
        if (buildingId!= null && !buildingId.equals("")) {
            sql.append(" AND building_id=#{buildingId}  ");
        }
        if (pumpId!= null && !pumpId.equals("")) {
            sql.append(" AND pump_id=#{pumpId}  ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" )T  where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit} order by T.cur_date ");
        } else if (page == 0){
            sql.append(" )T  order by T.cur_date ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询热泵时长记录
    public String pumpMonthMinutesCount(String startDate,String endDate,String buildingId,String pumpId){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (select *,ROW_NUMBER() over(order by cur_date) as rn from pump_month_minutes " +
                " where 1=1 ");
        if (startDate!= null && !startDate.equals("")) {
            sql.append(" AND cur_date>=#{startDate} ");
        }
        if (endDate!= null && !endDate.equals("")) {
            sql.append(" AND cur_date<=#{endDate} ");
        }
        if (buildingId!= null && !buildingId.equals("")) {
            sql.append(" AND building_id=#{buildingId} ");
        }
        if (pumpId!= null && !pumpId.equals("")) {
            sql.append(" AND pump_id=#{pumpId} ");
        }
        sql.append(" )T");
//        System.out.println(sql.toString());
        return sql.toString();
    }

}
