package com.mh.user.mapper.provider;

public class UseForecastProvider {

    public String queryUseForecast(String buildingId,String tankId,String curDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from use_forecast  " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (tankId != null && !tankId.equals("")){
            sql.append(" AND tank_id = #{tankId} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        if ((page != 0) && (limit != 0)){
            sql.append(" ) T join building T1  ON T.building_id=T1.id where T.rn>(#{page}-1)*#{limit} and T.rn<=#{page}*#{limit}");
        } else if (page == 0){
            sql.append(" ) T ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询记录数
    public String getCount(String buildingId,String tankId,String curDate, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select *,ROW_NUMBER() over(order by id) as rn from  use_forecast " +
                " where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND building_id = #{buildingId} ");
        }
        if (tankId != null && !tankId.equals("")){
            sql.append(" AND tank_id = #{tankId} ");
        }
        if (curDate!= null && !curDate.equals("")) {
            sql.append(" AND LEFT(cur_date,10)=#{curDate} ");
        }
        sql.append(" ) T  join building T1  ON T.building_id=T1.id ");

//        System.out.println(sql.toString());
        return sql.toString();
    }
}
