package com.mh.user.service;

import com.mh.user.entity.BuildingEntity;
import com.mh.user.model.BuildingModel;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface BuildingService {

    /**
     * 楼栋管理模块
     * 保存楼栋信息
     * @param buildingEntity
     */
    int saveBuilding(BuildingEntity buildingEntity);

    /**
     * 楼栋管理模块
     * 保存楼栋信息
     * @param buildingEntity
     */
    int updateBuilding(BuildingEntity buildingEntity);

    /**
     * 楼栋管理模块：
     * 查询楼栋资料
     * @param page
     * @param limit
     * @return
     */
    List<BuildingEntity> queryBuilding(String buildingId,int page, int limit);

    /**
     * 楼栋管理模块：
     * 获取楼栋信息查询的总条数
     * @return
     */
    int getCount(String buildingId,int page, int limit);

    //查询楼栋名称
    List<BuildingModel> selectBuildingName();

    //查询楼栋编号
    String selectBuildingId(String buildingName);

    int selectCount(@Param("buildingName") String buildingName);
    /**
     * 楼栋管理模块：
     * 根据名称删除楼栋信息
     * @param records
     */
    int deleteBuilding(List<BuildingEntity> records);

    /**
     * 楼栋管理模块：
     * 根据名称删除楼栋信息
     * @param id
     */
    int deleteBuilding(String id);

    //通过编号查询名称
    String queryBuildingName(String id);

    //查询水箱高度
    Double queryTankHeight(String id);

    //查询对应区域编号
    String queryAreaId(int id);

    //查询楼栋热泵数目
    int selectPumpCount(String buildingId);

    String selectBuildingNameById(String buildingId);
}
