package com.mh.user.service;

import com.mh.user.entity.BuildingEntity;
import com.mh.user.entity.DeviceInstallEntity;
import com.mh.user.entity.DeviceInstallTempEntity;
import com.mh.user.entity.UploadDeviceInstallEntity;
import com.mh.user.mapper.provider.DeviceInstallProvider;
import com.mh.user.model.DeviceModel;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;

import java.util.Date;
import java.util.List;

public interface DeviceInstallService {

     void createParamCode(DeviceInstallEntity deviceInstallEntity);

    /**
     * 设备管理模块
     * 保存设备信息
     *
     * @param deviceInstallEntity
     */
    int saveDevice(DeviceInstallEntity deviceInstallEntity);

    /**
     * 设备管理模块
     * 保存设备信息
     *
     * @param deviceInstallEntity
     */
    int updateDevice(DeviceInstallEntity deviceInstallEntity);

    //按id更新水电表读数和采集日期
    void updateLastValue(Long id, String lastValue, Date lastDate);
    /**
     * 设备管理模块
     * 查询设备资料
     *
     * @param page
     * @param limit
     * @return
     */
    List<DeviceInstallEntity> getAllDevice(int page, int limit);

    //查询有多个采集参数的设备
    List<DeviceInstallEntity> selectDeviceParams();

    //查询有多个采集参数的设备
    List<DeviceInstallEntity> selectDeviceParams2();

    //查询需要手动开关机的热泵
    List<DeviceInstallEntity> selectDevicePump();

    // 查询所有启用的设备
    int getAllCount();
    /**
     * 设备管理模块
     * 按条件查询设备资料
     * @param buildingId
     * @param startDate
     * @param startDate
     * @param page
     * @param limit
     * @return
     */
    List<DeviceInstallEntity> queryDevice(String buildingId,String deviceType, String startDate, String endDate,String isOnline, String isUse, String isFault, int page, int limit);

    /**
     * 设备管理模块：
     * 获取设备查询的总条数
     *
     * @return
     */
    int getCount(String buildingId,String deviceType, String startDate, String endDate,String isOnline, String isUse, String isFault, int page, int limit);

    //查询设备故障情况
    int getIsFaultCount(String isFault,String deviceType);

    //查询设备在线情况
    int getIsOnlineCount(String isOnline,String deviceType);

    // 修改设备在线状态
    void updateOnline(String deviceAddr,String deviceType,String buildingId,String isOnline);

    // 修改设备离线状态
    void updateNotOnline(String deviceAddr,String deviceType,String buildingId,String isOnline);

    //根据通讯地址和设备类型查询对应的设备信息
    DeviceInstallEntity selectDevice(String deviceAddr,String deviceType,String buildingId);

    //查询通讯编号是否存在
    int selectDeviceCount(String deviceAddr,String deviceType);
    /**
     * 设备管理模块
     * 根据通讯地址删除设备信息
     *
     * @param records
     */
    int deleteDevice(List<DeviceInstallEntity> records);

    /**
     * 设备管理模块
     * 根据通讯地址删除设备信息
     *
     * @param id
     */
    int deleteDevice(String id);

    // Excel导入相关函数
    // 删除临时表
    void deleteDevice_install_temp();

    // 插入临时表
    void insertDevice_install_temp(UploadDeviceInstallEntity uploadDeviceInstallEntity);

    // 查询Excel导入的数据
    List<DeviceInstallTempEntity> queryExcelDevices();

    // 查询Excel导入的数据的记录数
    int queryExcelDevicesCount();

    // 在导入中的数据有重复
    void updateDevice_install_temp__multiple();

    //从临时表查询插入
    void insertFromDevice_install_temp();

    //修改启动状态
    void updateDeviceIsUse(String isUse, String deviceAddr);

    //查询设备
    List<DeviceModel> selectDevices(String buildingId,String deviceType);

    //修改故障状态
    void updateDeviceFault(String isFault, String deviceAddr, String deviceType);

    //查询设备品牌
    String selectBrand(String buildingId,String deviceAddr);

    //修改使用状态1启用，0停用
    void updateIsUse(String isUse, String deviceAddr, String deviceType, String buildingId);

    //修改使用状态1启用，0停用
    void updateIsUse2(String isUse, String deviceAddr, String deviceType, String buildingId);

    //修改使用状态1启用，0停用
    void updateIsUse3(String isUse, String deviceAddr, String deviceType, String buildingId);

    //删除监控表停用热泵记录
    void deletePump(String deviceAddr,String deviceType,String buildingId);

    //更新基表初始值
    void updateInitValue(String deviceAddr, String deviceType, String buildingId, String initValue);

    //查询最后一次采集时间
    String selectLastDate(String deviceType,String deviceAddr,String buildingId);

    //判断某栋楼是否有热泵设备
    int judgePump(String buildingId);

    //查询设备所属位置（低区或高区）
    String selectSeat(String deviceType,String deviceAddr,String buildingId);

    /**
     * 更新设备校准值
     * @param buildingId
     * @param deviceType
     * @param param
     * @param readValue
     * @param realValue
     * @return
     */
    boolean updateDeviation(Integer buildingId, Integer deviceType, Integer param, String readValue, String realValue);

    Double selectDeviceDeviation(String deviceAddr, String deviceType, String buildingId);

    DeviceInstallEntity selectDeviceById(Long id);

    void deleteParamCode(DeviceInstallEntity oldEntity);

    void updateLastValueByOther(String addr, String strWtLevel, String deviceType, String buildingId);
}
