package com.mh.user.service;

import com.mh.user.entity.DeviceManageEntity;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ： 设备管理接口
 * @updateTime 2020-05-14
 * @throws ：
 */
public interface DeviceManageService {

    // 根据设备机身表号查询对应的设备信息
    List<DeviceManageEntity> getDeviceByOther(String deviceNum);

    void addOrUpdateBaseMeter(DeviceManageEntity deviceManageEntity);

    /**
     * 删除设备信息
     * @param deviceId
     * @param deviceType
     */
    void deleteDeviceInfo(Integer deviceId, String deviceType);

    // 通过设备类型查询设备信息 1：广仪电表  3：冷量计
    List<DeviceManageEntity> queryDevicesByType(String deviceType);

    // 查询全部信息
    List<DeviceManageEntity> queryAllDevice();

    // 根据设备ID查询对应的设备信息
    List<DeviceManageEntity> queryDeviceByOther(int page, int size, String deviceNum);

    // 查询设备总数
    int queryDeviceByOtherCount(String deviceNum);
}
