package com.mh.user.service.impl;

import com.mh.user.entity.DeviceParameterEntity;
import com.mh.user.mapper.DeviceParamMapper;
import com.mh.user.service.DeviceParamService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ： 实现类
 * @updateTime 2020-05-21
 * @throws ：
 */
@Service
public class DeviceParamServiceImpl implements DeviceParamService {

    private final DeviceParamMapper deviceParamMapper;

    public DeviceParamServiceImpl(DeviceParamMapper deviceParamMapper) {
        this.deviceParamMapper = deviceParamMapper;
    }

    @Override
    public List<DeviceParameterEntity> getBaseMeterParamList(String baseMeterType) {
        return deviceParamMapper.getBaseMeterParamList(baseMeterType);
    }

    @Override
    public void addOrUpdateBaseMeterParam(DeviceParameterEntity deviceParameterEntity) {
        if(deviceParameterEntity.getType().equals("edit")){
            deviceParamMapper.updateBaseMeterParam(deviceParameterEntity);
        }else if(deviceParameterEntity.getType().equals("add")){
            deviceParamMapper.insertBaseMeterParam(deviceParameterEntity);
        }
    }

    @Override
    public String insertDeviceParam(DeviceParameterEntity deviceParameterEntity) {
        // 判断是否已经包含
        DeviceParameterEntity deviceParameterEntity1 = deviceParamMapper.queryParamById(deviceParameterEntity.getParamId());
        if (deviceParameterEntity1.getId() != null) {
            return "数据重复，请重新插入";
        } else {
            deviceParamMapper.insertDeviceParam(deviceParameterEntity);
            return "数据插入成功";
        }
    }

    @Override
    public void deleteDeviceParamByID(Long id) {
        deviceParamMapper.deleteDeviceParamByID(id);
    }

    @Override
    public DeviceParameterEntity queryParamById(int paramId) {
        return deviceParamMapper.queryParamById(paramId);
    }

    @Override
    public List<DeviceParameterEntity> queryAll() {
        return deviceParamMapper.queryAll();
    }

    @Override
    public List<DeviceParameterEntity> queryByOther(int page, int size, int paramId) {
        return deviceParamMapper.queryByOther(page, size, paramId);
    }

    @Override
    public int queryByOtherCount(int page, int size, int paramId) {
        return deviceParamMapper.queryByOtherCount(page, size, paramId);
    }
}
