package com.mh.user.service.impl;

import com.mh.user.entity.GaugeEntity;
import com.mh.user.entity.TableChartMessageEntity;
import com.mh.user.mapper.GaugeMapper;
import com.mh.user.service.GaugeService;
import org.springframework.stereotype.Service;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-08-07
 * @throws ：
 */
@Service
public class GaugeServiceImpl implements GaugeService {

    private final GaugeMapper gaugeMapper;

    public GaugeServiceImpl(GaugeMapper gaugeMapper) {
        this.gaugeMapper = gaugeMapper;
    }


    @Override
    public GaugeEntity getGaugeData(String type, String deviceName) {
        try {
            TableChartMessageEntity tableChartMessageEntity = gaugeMapper.queryDeviceId(type, deviceName);
            GaugeEntity gaugeEntity = gaugeMapper.getGaugeData(tableChartMessageEntity.getTimeName(),tableChartMessageEntity.getGrade());
            if (type.equalsIgnoreCase("0")) {
                gaugeEntity.setMax("5000");
            } else if (type.equalsIgnoreCase("1")) {
                gaugeEntity.setMax("20");
            } else if (type.equalsIgnoreCase("2")) {
                gaugeEntity.setMax("2500");
            } else if (type.equalsIgnoreCase("3")) {
                gaugeEntity.setMax("10");
            }
            return gaugeEntity;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public TableChartMessageEntity queryDeviceId(String type, String deviceName) {
        return gaugeMapper.queryDeviceId(type, deviceName);
    }
}
