package com.mh.user.service.impl;

import com.mh.user.entity.AlarmInfoSumEntity;
import com.mh.user.entity.DeviceStateEntity;
import com.mh.user.entity.EnergySumEntity;
import com.mh.user.entity.MaintainSumEntity;
import com.mh.user.mapper.SummaryMapper;
import com.mh.user.service.SummaryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class SummaryServiceImpl implements SummaryService {

    @Autowired
    SummaryMapper summaryMapper;

    @Override
    public DeviceStateEntity queryDeviceState() {
        return summaryMapper.queryDeviceState();
    }

    @Override
    public EnergySumEntity queryEnergySum(String buildingId, String curDate, int type) {
        if (type==1){
            return summaryMapper.queryEnergyDaySum(buildingId,curDate);   //日
        }else if (type==2){
            return summaryMapper.queryEnergyMonthSum(buildingId,curDate); //月
        }else {
            return summaryMapper.queryEnergyYearSum(buildingId,curDate);  //年
        }
    }

    @Override
    public MaintainSumEntity queryMaintainSum(String buildingId, String curDate) {
        return summaryMapper.queryMaintainSum(buildingId,curDate);
    }

    @Override
    public AlarmInfoSumEntity queryAlarmInfoSum(String buildingId, String curDate) {
        return summaryMapper.queryAlarmInfoSum(buildingId,curDate);
    }
}
