package com.mh.user.utils;

import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Date;

/**
 * @author ljf
 * @title ：
 * @description ： 创建文件
 * @updateTime 2020-09-17
 * @throws ：
 */
public class FileUtils {

    public static void createFileAndWrite(String writeStr, int type) {

        String timeStr = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyyMMdd"));
        String fileName = "D:/meterLog"+timeStr+".txt";
        File file = new File(fileName);
        try {
            if (!file.exists()) {
                file.createNewFile();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        Path path = Paths.get(fileName);
        // 使用newBufferedWriter创建文件并写文件
        // 这里使用了try-with-resources方法来关闭流，不用手动关闭
//            try (BufferedWriter writer =
//                         Files.newBufferedWriter(path, StandardCharsets.UTF_8)) {
//                writer.write("Hello World -创建文件!!");
//            } catch (IOException e) {
//                e.printStackTrace();
//            }

        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append(LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")))
                .append(" ")
                .append(writeStr);
        if (1==type) {
            stringBuilder.append(" 接收到的报文\t\n");
        } else {
            stringBuilder.append(" 发送的报文\t\n");
        }
        //追加写模式
        try (BufferedWriter writer =
                     Files.newBufferedWriter(path,
                             StandardCharsets.UTF_8,
                             StandardOpenOption.APPEND)){
            writer.write(stringBuilder.toString());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
