package com.mh.user.utils;

import com.mh.user.entity.DeviceCodeParamEntity;
import lombok.extern.slf4j.Slf4j;

/**
 * @author ljf
 * @title ：
 * @description ： 发送指令工具类
 * @updateTime 2021-01-26
 * @throws ：
 */
@Slf4j
public class SendOrderUtils {

	//向串口发指令数据
	public static String getSendStr(DeviceCodeParamEntity deviceCodeParamEntity) {
		//创建将要写出的数据
		String deviceType=deviceCodeParamEntity.getDeviceType();
		String sendStr=null;
		switch (deviceType) {
			case "电表":
				sendStr = GetReadOrder485.createMeterOrder(deviceCodeParamEntity);
				break;
			case "水表":
				sendStr = GetReadOrder485.createWtMeterOrder(deviceCodeParamEntity);
				break;
			case "压变":
				sendStr = GetReadOrder485.createPressureOrder(deviceCodeParamEntity);
				break;
			case "热泵":
				sendStr = GetReadOrder485.createPumpOrder(deviceCodeParamEntity);
				break;
			case "温控":
				sendStr = GetReadOrder485.createTempOrder(deviceCodeParamEntity);
				break;
			case "时控":
				sendStr = GetReadOrder485.createTimeSetOrder(deviceCodeParamEntity);
				break;
			case "水位开关":
				sendStr = GetReadOrder485.createRelayOrder(deviceCodeParamEntity);
				break;
			case "状态检测":
				sendStr = GetReadOrder485.createStateOrder(deviceCodeParamEntity);
				break;
			case "温度变送器":
				sendStr = GetReadOrder485.createMulTempOrder(deviceCodeParamEntity);
				break;
			case "热泵状态":
				sendStr = GetReadOrder485.createPumpStateOrder(deviceCodeParamEntity);
				break;
		}

		return sendStr;
	}
}
