package com.mh.user.utils;

import com.mh.user.annotation.BusinessType;
import com.mh.user.constants.Constant;
import com.mh.user.entity.DeviceManageEntity;
import com.mh.user.service.NowDataService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-05-15
 * @throws ：
 */
@Slf4j
public class Test {

//    @Autowired
//    protected DeviceManageService deviceManageService;
//    private static Test  test ;
//    @PostConstruct //通过@PostConstruct实现初始化bean之前进行的操作
//    public void init() {
//        test = this;
//        test.deviceManageService = this.deviceManageService;
//        // 初使化时将已静态化的testService实例化
//    }
//
//    //测试调用
//    public void test1(){
//
//    }

    public void myAnalysisCloudOrder485(String receiveData){

        // 去掉空格
        receiveData = receiveData.replace(" ","");

        // 检验报文
        String checkStr = receiveData.substring(0,receiveData.length()-4);
        byte[] strOrder = ExchangeStringUtil.hexStrToBinaryStr(checkStr);
        int checkNum = CRC16.CRC16_MODBUS(strOrder);
        String checkWord = ExchangeStringUtil.decToHex(String.valueOf(checkNum));
        checkWord = checkWord.substring(2,4) + checkWord.substring(0,2);

        if (checkWord.equalsIgnoreCase(receiveData.substring(receiveData.length()-4,receiveData.length()))) {

            log.info("报文检验成功: " + receiveData);

            // IP地址
            String ip = checkStr.substring(0, 8);
            // 端口号
            String port = checkStr.substring(8, 12);
            // COM口
            String dataCom = checkStr.substring(12, 14);
            // 数据
            String dataStr1 = checkStr.substring(14);

            // 检验报文
            String checkStr1 = dataStr1.substring(0, dataStr1.length() - 4);
            byte[] strOrder1 = ExchangeStringUtil.hexStrToBinaryStr(checkStr1);
            int checkNum1 = CRC16.CRC16_MODBUS(strOrder1);
            String checkWord1 = ExchangeStringUtil.decToHex(String.valueOf(checkNum1));
            checkWord1 = checkWord1.substring(2, 4) + checkWord1.substring(0, 2);
            if (checkWord1.equalsIgnoreCase(dataStr1.substring(dataStr1.length() - 4))) {

                // 时间
                //创建SimpleDateFormat对象，指定样式    2019-05-13 22:39:30
                SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                Date date = new Date();
                String dateStr = sdf1.format(date);
                log.info("时间： " + dateStr);

                // 表号
                String cloudId = ExchangeStringUtil.hexToDec(dataStr1.substring(0, 2));
                log.info("冷量计ID： " + cloudId);

                // 读数
                String data = dataStr1.substring(dataStr1.length() - 8, dataStr1.length() - 6)
                        + dataStr1.substring(dataStr1.length() - 6, dataStr1.length() - 4)
                        + dataStr1.substring(dataStr1.length() - 12, dataStr1.length() - 10)
                        + dataStr1.substring(dataStr1.length() - 10, dataStr1.length() - 8);
                data = ExchangeStringUtil.hexToDec(data);
                log.info("冷量计读数： " + data);

                try {
                    DeviceManageEntity deviceManageEntity = new DeviceManageEntity();
                    deviceManageEntity.setDeviceNum(cloudId);
                    deviceManageEntity.setDeviceCode(cloudId);
                    deviceManageEntity.setLastValue(data);
                    deviceManageEntity.setLastDate(new Date());

                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }

    }

    public static void main(String[] args) throws ParseException, IOException {


    }

}
