package com.mh.user;

import com.mh.user.entity.DeviceManageEntity;
import com.mh.user.entity.GaugeEntity;
import com.mh.user.serialport.SerialPortThread;
import com.mh.user.service.DeviceManageService;
import com.mh.user.service.GaugeService;
import com.mh.user.utils.*;
import org.checkerframework.checker.units.qual.A;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ThreadPoolExecutor;

@SpringBootTest
class UserServiceApplicationTests {

  @Test
  void contextLoads() {
  }

  @Test
  public void encode() {
    String s = PasswordUtils.encode("123456", "87e03afa1f0122531f729c9a7453f475");
    System.out.println(s);
    System.out.println(new PasswordEncoder("87e03afa1f0122531f729c9a7453f475").matches(s, "123456"));
  }

  @Autowired
  private GaugeService gaugeService;

  @Test
  public void getGaugeData() {
    GaugeEntity gaugeEntity = gaugeService.getGaugeData("0", "1号冷水机");
    System.out.println(gaugeEntity.toString());
  }

  @Autowired
  DeviceManageService deviceManageService;

  @Test
  public void queryDevices() {
    List<DeviceManageEntity> deviceManageEntities = deviceManageService.queryDevicesByType(null);
    for (DeviceManageEntity device :
      deviceManageEntities) {
      System.out.println(device.toString());
    }
  }

  @Test
  public void AnalysisTest() {
    AnalysisReceiveOrder485 analysis=new AnalysisReceiveOrder485();
    GetReadOrder485 getReadOrder485=new GetReadOrder485();
//    analysis.analysisWtMeterOrder485("FEFEFE6810398710810000008116901F00006502002C006502002C0000000000000000FF3416");
    //0203020008FD82
//    analysis.analysisPumpOrder485("0203020008FD82","0641");
//    getReadOrder485.createOrderParam();
    analysis.analysisTimeSetOrder4852("0B10000900041162",null, null, null, null);
  }
  @Test
  public void testHotWater() throws InterruptedException {
    while (true) {
      ThreadPoolExecutor comThreadPool = ComThreadPoolService.getInstance();
      try {
        for (int i = 1; i <= 4; i++) {
          String threadName;
          if (i == 1 || i == 3) {
            threadName = "1";
            System.out.println("------采集水位、水温！" + i + "------");
          } else if (i == 2) {
            threadName = "2";
            System.out.println("------采集水、电、运行状态！" + i + "------");
          } else {
            threadName = "3";
            System.out.println("------采集设定温度、设定水位、故障状态！" + i + "------");
          }
          CountDownLatch countDownLatch = new CountDownLatch(10);
          for (int j = 1; j < 11; j++) {
            SerialPortThread myThread = new SerialPortThread();
            myThread.setName(threadName, String.valueOf(j), countDownLatch);
            Thread thread = new Thread(myThread);
            comThreadPool.submit(thread);
          }
          countDownLatch.await();
        }
      } catch (InterruptedException e) {
        throw new RuntimeException(e);
      } finally {
      }
    }
  }

  @Test
  public void testGetPump() {
    String dataValue = "03002200";
    System.out.println(ExchangeStringUtil.IntToHex(Integer.parseInt(dataValue.substring(0, 2))));
    System.out.println(ExchangeStringUtil.IntToHex(Integer.parseInt(dataValue.substring(2, 4))));
    System.out.println(ExchangeStringUtil.IntToHex(Integer.parseInt(dataValue.substring(4, 6))));
    System.out.println(ExchangeStringUtil.IntToHex(Integer.parseInt(dataValue.substring(6, 8))));
    String strData = "00" + ExchangeStringUtil.addZeroForNum(ExchangeStringUtil.IntToHex(Integer.parseInt(dataValue.substring(0, 2))),2)
            + "00" + ExchangeStringUtil.addZeroForNum(ExchangeStringUtil.IntToHex(Integer.parseInt(dataValue.substring(2, 4))),2)
            + "00" + ExchangeStringUtil.addZeroForNum(ExchangeStringUtil.IntToHex(Integer.parseInt(dataValue.substring(4, 6))),2)
            + "00" + ExchangeStringUtil.addZeroForNum(ExchangeStringUtil.IntToHex(Integer.parseInt(dataValue.substring(6, 8))),2);
    System.out.println(strData);
    AnalysisReceiveOrder485 analysisReceiveOrder485 = new AnalysisReceiveOrder485();
    analysisReceiveOrder485.analysisRelayOrder4852("26 03 10 00 00 00 00 00 01 00 01 00 01 00 01 00 00 00 00 FE 86 ".replace(" ", ""), "0018", "远向", "1", "1栋");
  }
}
