//package com.mh.user.socket;
//
//import com.mh.user.utils.ExchangeStringUtil;
//import io.netty.bootstrap.ServerBootstrap;
//import io.netty.buffer.ByteBuf;
//import io.netty.buffer.Unpooled;
//import io.netty.channel.*;
//import io.netty.channel.nio.NioEventLoopGroup;
//import io.netty.channel.socket.SocketChannel;
//import io.netty.channel.socket.nio.NioServerSocketChannel;
//import io.netty.handler.logging.LogLevel;
//import io.netty.handler.logging.LoggingHandler;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.util.StringUtils;
//
//import java.io.IOException;
//import java.net.InetSocketAddress;
//
//
///**
// * @author ljf
// * @title ：Netty
// * @description ：netty 使用
// * @updateTime 2020-04-21
// * @throws ：
// */
//@Slf4j
//public class NettyEchoServer {
//
//    public void bind(int port) throws Exception {
//        // accept线程组，用来接收连接
//        EventLoopGroup bossGroup = new NioEventLoopGroup(1);
//        // IO 线程组，用来处理业务逻辑
//        EventLoopGroup workerGroup = new NioEventLoopGroup(1);
//
//        try {
//            // 服务端启动引导
//            ServerBootstrap serverBootstrap = new ServerBootstrap();
//            serverBootstrap.group(bossGroup,workerGroup)                        // 绑定两个线程
//                            .channel(NioServerSocketChannel.class)              // 指定通道类型
//                            .option(ChannelOption.SO_BACKLOG, 1024)       // 设置TCP连接的缓冲区
//                            .handler(new LoggingHandler(LogLevel.INFO))         // 设置日志级别
//                            .childHandler(new ChannelInitializer<SocketChannel>() {
//                                @Override
//                                protected void initChannel(SocketChannel socketChannel) throws Exception {
//                                    ChannelPipeline pipeline = socketChannel.pipeline();        // 获取处理器链
//                                    pipeline.addLast(new EchoServerHandler());                  // 添加新的事件处理器
//                                }
//                            });
//            // 通过bind启动服务
//            ChannelFuture f = serverBootstrap.bind(port).sync();
//            // 阻塞主线程，知道网络服务被关闭
//            f.channel().closeFuture().sync();
//        } catch (Exception e){
//            e.printStackTrace();
//        } finally {
//            workerGroup.shutdownGracefully();
//            bossGroup.shutdownGracefully();
//        }
//    }
//
//    static class EchoServerHandler extends  ChannelHandlerAdapter  {
//
//        // 每当从客户端收到新的数据时，这个方法会在收到消息时被调用
//        @Override
//        public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
//            try {
//                ByteBuf buf = (ByteBuf)msg;
//                byte [] bytes = new byte[buf.readableBytes()];
//                buf.readBytes(bytes);//复制内容到字节数组bytes
//                String receiveStr = ExchangeStringUtil.bytesToHexString(bytes);//将接收到的数据转为字符串，此字符串就是客户端发送的字符串
//                log.info("接收到的数据： "+ receiveStr);
//                //返回16进制到客户端
//                writeToClient(receiveStr,ctx,"测试");
//            } catch (Exception e) {
//                // TODO Auto-generated catch block
//                e.printStackTrace();
//            }
////            ctx.write(Unpooled.wrappedBuffer("Server message".getBytes()));
////            ctx.fireChannelRead(msg);
//        }
//
//        // 数据读取完后被调用
//        @Override
//        public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {
//            ctx.flush();
//        }
//
//        // 当Netty由于IO错误或者处理器在处理事件时抛出的异常时被调用
//        @Override
//        public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
//            cause.printStackTrace();
//            ctx.close();
//        }
//
//        /**
//         * 客户端与服务端第一次建立连接时 执行
//         *
//         * @param ctx
//         * @throws Exception
//         */
//        @Override
//        public void channelActive(ChannelHandlerContext ctx) throws Exception, IOException
//        {
//            super.channelActive(ctx);
//            ctx.channel().read();
//            InetSocketAddress ifsock = (InetSocketAddress) ctx.channel().remoteAddress();
//            String clientIp = ifsock.getAddress().getHostAddress();
//            //此处不能使用ctx.close()，否则客户端始终无法与服务端建立连接
//            log.info("channelActive: "+clientIp + ctx.name());
//        }
//
//        /**
//         * 客户端与服务端 断连时 执行
//         *
//         * @param ctx
//         * @throws Exception
//         */
//        @Override
//        public void channelInactive(ChannelHandlerContext ctx) throws Exception, IOException
//        {
//            super.channelInactive(ctx);
//            InetSocketAddress ifsock = (InetSocketAddress) ctx.channel().remoteAddress();
//            String clientIp = ifsock.getAddress().getHostAddress();
//            ctx.close(); //断开连接时，必须关闭，否则造成资源浪费，并发量很大情况下可能造成宕机
//            System.out.println("channelInactive:"+clientIp);
//        }
//
//        /**
//         * 服务端当read超时, 会调用这个方法
//         *
//         * @param ctx
//         * @param evt
//         * @throws Exception
//         */
//        @Override
//        public void userEventTriggered(ChannelHandlerContext ctx, Object evt) throws Exception, IOException
//        {
//            super.userEventTriggered(ctx, evt);
//            InetSocketAddress ifsock = (InetSocketAddress) ctx.channel().remoteAddress();
//            String clientIp = ifsock.getAddress().getHostAddress();
//            ctx.close();//超时时断开连接
//            System.out.println("userEventTriggered:"+clientIp);
//        }
//
//
//        /**
//         * 公用回写数据到客户端的方法
//         * @param channel
//         * @param mark 用于打印/log的输出
//         * <br>//channel.writeAndFlush(msg);//不行
//         * <br>//channel.writeAndFlush(receiveStr.getBytes());//不行
//         * <br>在netty里，进出的都是ByteBuf，楼主应确定服务端是否有对应的编码器，将字符串转化为ByteBuf
//         */
//        private void writeToClient(final String receiveStr, ChannelHandlerContext channel, final String mark) {
//            try {
//                ByteBuf buff = Unpooled.buffer();//netty需要用ByteBuf传输
//                buff.writeBytes(ExchangeStringUtil.hexStrToBinaryStr(receiveStr));//对接需要16进制
//                channel.writeAndFlush(buff).addListener(new ChannelFutureListener() {
//                    @Override
//                    public void operationComplete(ChannelFuture future) throws Exception {
//                        StringBuilder sb = new StringBuilder("");
//                        if(!StringUtils.isEmpty(mark)){
//                            sb.append("【").append(mark).append("】");
//                        }
//                        if (future.isSuccess()) {
//                            System.out.println(sb.toString()+"回写成功"+receiveStr);
//                            log.info(sb.toString()+"回写成功"+receiveStr);
//                        } else {
//                            System.out.println(sb.toString()+"回写失败"+receiveStr);
//                            log.error(sb.toString()+"回写失败"+receiveStr);
//                        }
//                    }
//                });
//            } catch (Exception e) {
//                e.printStackTrace();
//                System.out.println("调用通用writeToClient()异常"+e.getMessage());
//                log.error("调用通用writeToClient()异常：",e);
//            }
//        }
//    }
//}
